SystemOrganization addCategory: #'Pier-Filing'!

Object subclass: #PFExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 12:51'!
exportDefault
	self 
		exportStructure: PRKernel instances anyOne root
		to: FileDirectory default pathName.
! !

!PFExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 12:49'!
exportProperty: aProperty value: aString to: aPath
	| stream |
	stream := (FileDirectory on: aPath) forceNewFileNamed: aProperty.
	aString ifNotNil: [
		stream nextPutAll: aString ].
	stream close! !

!PFExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 12:50'!
exportStructure: aStructure to: aFolderPath
	| newName newPath stream value selectors description |
	newName := aStructure name, '.', aStructure class name.
	(FileDirectory on: aFolderPath) createDirectory: newName.
	newPath := aFolderPath, FileDirectory slash, newName.
	aStructure enumerator do: [:each |
		self exportStructure: each to: newPath ].
	selectors := aStructure class class allSelectors select: [ :each | each isDescriptionSelector and: [each isUnary] ].	
	selectors do: [:eachSel |
		description := aStructure class perform: eachSel.
		value := description toString: (aStructure readUsing: description).
		self exportProperty: eachSel value: value to: newPath
		]! !

PRVisitor subclass: #PFHardcodedExporter
	instanceVariableNames: 'path value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFHardcodedExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 12:51'!
exportDefault
	self 
		exportStructure: PRKernel instances anyOne root
		to: FileDirectory default pathName.
! !

!PFHardcodedExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 12:49'!
exportStructure: aStructure to: aFolderPath
	| newName newPath stream value selectors description |
	newName := aStructure name, '.', aStructure class name.
	(FileDirectory on: aFolderPath) createDirectory: newName.
	newPath := aFolderPath, FileDirectory slash, newName.
	aStructure enumerator do: [:each |
		self exportStructure: each to: newPath ].
	aStructure accept: (self new path: newPath)! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:00'!
exportCollectionProperty: aString value: aCollection
 	| string |
	string := String new.
	aCollection do: [:each | string := string, each] separatedBy: [string := string, ','].
	self exportProperty: aString value: string.! !

!PFHardcodedExporter methodsFor: 'private' stamp: 'tg 11/3/2009 02:40'!
exportProperty: aProperty of: aStructure
	self exportProperty: aProperty value: (aStructure perform: aProperty asSymbol)! !

!PFHardcodedExporter methodsFor: 'private' stamp: 'tg 11/3/2009 02:40'!
exportProperty: aProperty value: aString
	| stream |
	stream := (FileDirectory on: self path) forceNewFileNamed: aProperty.
	aString ifNotNil: [
		stream nextPutAll: aString ].
	stream close! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 02:45'!
exportTagsOf: aStructure
 	| tags |
	tags := String new.
	aStructure tags do: [:each | tags := tags, each] separatedBy: [tags := tags, ','].
	self exportProperty: 'tags' value: tags.! !

!PFHardcodedExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path
	^ path! !

!PFHardcodedExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path: anObject
	path := anObject! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 12/6/2009 23:57'!
visitBlog: aStructure
	self visitCase: aStructure.
	self exportProperty: 'copyright' of: aStructure.
	self exportProperty: 'language' of: aStructure.! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 12/6/2009 23:57'!
visitCase: aStructure
	self exportProperty: 'title' of: aStructure.
	self exportProperty: 'contents' of: aStructure.
	self exportTagsOf: aStructure.! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:00'!
visitComponent: aStructure
	self exportProperty: 'componentClass' value: aStructure componentClass name asString! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 12/6/2009 23:57'!
visitEntry: aStructure
	self visitCase: aStructure.
	self exportProperty: 'author' of: aStructure.
	self exportProperty: 'publication' value: (
		aStructure publication ifNotNil: [ aStructure publication asString ] ).! !

!PFHardcodedExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:03'!
visitFile: aStructure
"	self exportProperty: 'contents' value: aStructure contents."
	self exportProperty: 'filename' value: aStructure file filename.
	self exportCollectionProperty: 'location' value: aStructure file location.
	self exportProperty: 'mimetype' value: aStructure file mimetype.! !

PRVisitor subclass: #PFHardcodedImporter
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFHardcodedImporter commentStamp: 'TudorGirba 8/14/2011 20:31' prior: 0!
self importDefault!

!PFHardcodedImporter class methodsFor: 'as yet unclassified' stamp: 'tg 12/7/2009 00:19'!
import: aDirectory
	"self import: FileDirectory default pathName, FileDirectory slash, 'pier.PRPage'"
	| structure |
	structure := PRPage named: 'root'.
	self import: aDirectory into: structure.
	^ structure childrenDecoration children first
		instVarNamed: 'parent' put: nil;
		yourself! !

!PFHardcodedImporter class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/14/2011 20:16'!
import: aPath into: aStructure
	| newName typeName newStruct directory |
	directory := FileDirectory on: aPath.
	typeName := (aPath subStrings: '.') last.
	(Smalltalk includesKey: typeName asSymbol) ifFalse: [^ self].
	newName := directory localName copyFrom: 1 to: directory localName size - (typeName size + 1).
	newName := newName replaceAll: Character space with: $-.
	newStruct := (Smalltalk at: typeName asSymbol) named: newName.
	newStruct accept: (self new path: directory; yourself).
	directory directoryNames do: [ :each |
		self import: (aPath, FileDirectory slash, each) into: newStruct ].
	aStructure addChild: newStruct! !

!PFHardcodedImporter class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 8/14/2011 20:33'!
importDefault
	| structureToImport |
	structureToImport := self import: FileDirectory default pathName, FileDirectory slash, 'pier.PRPage'.
	PRKernel instances anyOne root addChild: structureToImport! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:11'!
importPropertiesOf: aStructure except: aCollection
	self path fileNames do: [ :each |
		((each beginsWith: '.') or: [aCollection includes: each]) ifFalse: [
			self read: each do: [ :stream |
				aStructure perform: (each, ':') asSymbol with: stream contents ] 
			]
		]! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:11'!
importPublicationIn: aStructure
	| contents |
	self read: 'publication' do: [ :stream |
		contents := stream contents.
		(contents isEmpty or: [ contents = 'nil' ]) ifFalse: [
			aStructure publication: (TimeStamp fromString: contents)] ]! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:11'!
importTagsIn: aStructure
	self read: 'tags' do: [ :stream |
		aStructure tags: (stream contents subStrings: ',') ]! !

!PFHardcodedImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path
	^ path! !

!PFHardcodedImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path: anObject
	path := anObject! !

!PFHardcodedImporter methodsFor: 'private' stamp: 'tg 11/3/2009 13:10'!
read: aString do: aBlock
	| stream |
	(self path fileExists: aString) ifFalse: [ ^ nil ].
	stream := self path oldFileNamed: aString.
	^ [ aBlock value: stream ] ensure: [ stream close ]! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 03:08'!
visitCase: aStructure
	self importPropertiesOf: aStructure except: #()! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:25'!
visitComment: aStructure
	self importPropertiesOf: aStructure except: #(publication).
	self importPublicationIn: aStructure! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:11'!
visitComponent: aStructure
	self read: 'componentClass' do: [ :stream |
			aStructure componentClass: (Smalltalk at: stream contents asSymbol ifAbsent: [nil]) ]! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 13:21'!
visitFile: aStructure
	self importPropertiesOf: aStructure except: #(location).
	self read: 'location' do: [ :stream |
			aStructure file instVarNamed: 'location' put: (stream contents subStrings: ',') ]! !

!PFHardcodedImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 04:26'!
visitPost: aStructure
	self importPropertiesOf: aStructure except: #(publication tags).
	self importPublicationIn: aStructure.
	self importTagsIn: aStructure! !
